diff --git a/src/libs/zbxcrypto/tls.c b/src/libs/zbxcrypto/tls.c
index 7338883..b720452 100644
--- a/src/libs/zbxcrypto/tls.c
+++ b/src/libs/zbxcrypto/tls.c
@@ -1921,6 +2361,117 @@ small_buf:
 
 	return FAIL;
 }
+#elif defined(HAVE_MBEDTLS21)
+/******************************************************************************
+ *                                                                            *
+ * Function: zbx_x509_dn_gets                                                 *
+ *                                                                            *
+ * Purpose:                                                                   *
+ *     Print distinguished name (i.e. issuer, subject) into buffer. Intended  *
+ *     to use as an alternative to PolarSSL mbedtls_x509_dn_gets() to meet    *
+ *     application needs.                                                     *
+ *                                                                            *
+ * Parameters:                                                                *
+ *     dn    - [IN] pointer to distinguished name                             *
+ *     buf   - [OUT] output buffer                                            *
+ *     size  - [IN] output buffer size                                        *
+ *     error - [OUT] dynamically allocated memory with error message          *
+ *                                                                            *
+ * Return value:                                                              *
+ *     SUCCEED - no errors, FAIL - an error occurred                          *
+ *                                                                            *
+ * Comments:                                                                  *
+ *     This function is derived from PolarSSL mbedtls_x509_dn_gets() and      *
+ *     heavily modified to print RDNs in reverse order, to print UTF-8        *
+ *     characters and non-printable characters in a different way than        *
+ *     original mbedtls_x509_dn_gets() does and to return error messages.     *
+ *     Multi-valued RDNs are not supported currently.                         *
+ *                                                                            *
+ ******************************************************************************/
+static int	zbx_x509_dn_gets(const mbedtls_x509_name *dn, char *buf, size_t size, char **error)
+{
+	const mbedtls_x509_name	*node, *stop_node = NULL;
+	const char	*short_name = NULL;
+	char		*p, *p_end;
+
+	/* We need to traverse a linked list of RDNs and print them out in reverse order (recommended by RFC 4514).   */
+	/* The number of RDNs in DN is expected to be small (typically 4-5, sometimes up to 8). For such a small list */
+	/* we simply traverse it multiple times for getting elements in reverse order. */
+
+	p = buf;
+	p_end = buf + size;
+
+	while (1)
+	{
+		node = dn;
+
+		while (stop_node != node->next)
+			node = node->next;
+
+		if (NULL != node->oid.p)
+		{
+			if (buf != p)				/* not the first RDN */
+			{
+				if (p_end - 1 == p)
+					goto small_buf;
+
+				p += zbx_strlcpy(p, ",", (size_t)(p_end - p));	/* separator between RDNs */
+			}
+
+			/* write attribute name */
+
+			if (0 == mbedtls_oid_get_attr_short_name(&node->oid, &short_name))
+			{
+				if (p_end - 1 == p)
+					goto small_buf;
+
+				p += zbx_strlcpy(p, short_name, (size_t)(p_end - p));
+			}
+			else	/* unknown OID name, write in numerical form */
+			{
+				int	res;
+
+				if (p_end - 1 == p)
+					goto small_buf;
+
+				if (0 < (res = mbedtls_oid_get_numeric_string(p, (size_t)(p_end - p), &node->oid)))
+					p += (size_t)res;
+				else
+					goto small_buf;
+			}
+
+			if (p_end - 1 == p)
+				goto small_buf;
+
+			p += zbx_strlcpy(p, "=", (size_t)(p_end - p));
+
+			/* write attribute value */
+
+			if (p_end - 1 == p)
+				goto small_buf;
+
+			p += zbx_print_rdn_value(node->val.p, node->val.len, (unsigned char *)p, (size_t)(p_end - p),
+					error);
+
+			if (NULL != *error)
+				break;
+		}
+
+		if (dn->next != stop_node)
+			stop_node = node;
+		else
+			break;
+	}
+
+	if (NULL == *error)
+		return SUCCEED;
+	else
+		return FAIL;
+small_buf:
+	*error = zbx_strdup(*error, "output buffer too small");
+
+	return FAIL;
+}
 #elif defined(HAVE_GNUTLS)
 /******************************************************************************
  *                                                                            *
@@ -2226,6 +2777,9 @@ static void	zbx_log_peer_cert(const char *function_name, const zbx_tls_context_t
 #if defined(HAVE_POLARSSL)
 	const x509_crt		*cert;
 	char			issuer[HOST_TLS_ISSUER_LEN_MAX], subject[HOST_TLS_SUBJECT_LEN_MAX], serial[128];
+#elif defined(HAVE_MBEDTLS21)
+	const mbedtls_x509_crt		*cert;
+	char			issuer[HOST_TLS_ISSUER_LEN_MAX], subject[HOST_TLS_SUBJECT_LEN_MAX], serial[128];
 #elif defined(HAVE_GNUTLS)
 	gnutls_x509_crt_t	cert;
 	int			res;
@@ -2259,6 +2813,28 @@ static void	zbx_log_peer_cert(const char *function_name, const zbx_tls_context_t
 		zabbix_log(LOG_LEVEL_DEBUG, "%s() peer certificate issuer:\"%s\" subject:\"%s\" serial:\"%s\"",
 				function_name, issuer, subject, serial);
 	}
+#elif defined(HAVE_MBEDTLS21)
+	if (NULL == (cert = mbedtls_ssl_get_peer_cert(tls_ctx->ctx)))
+	{
+		zabbix_log(LOG_LEVEL_DEBUG, "%s() cannot obtain peer certificate", function_name);
+	}
+	else if (SUCCEED != zbx_x509_dn_gets(&cert->issuer, issuer, sizeof(issuer), &error))
+	{
+		zabbix_log(LOG_LEVEL_DEBUG, "%s() cannot obtain peer certificate issuer: %s", function_name, error);
+	}
+	else if (SUCCEED != zbx_x509_dn_gets(&cert->subject, subject, sizeof(subject), &error))
+	{
+		zabbix_log(LOG_LEVEL_DEBUG, "%s() cannot obtain peer certificate subject: %s", function_name, error);
+	}
+	else if (0 > mbedtls_x509_serial_gets(serial, sizeof(serial), &cert->serial))
+	{
+		zabbix_log(LOG_LEVEL_DEBUG, "%s() cannot obtain peer certificate serial", function_name);
+	}
+	else
+	{
+		zabbix_log(LOG_LEVEL_DEBUG, "%s() peer certificate issuer:\"%s\" subject:\"%s\" serial:\"%s\"",
+				function_name, issuer, subject, serial);
+	}
 #elif defined(HAVE_GNUTLS)
 	if (NULL == (cert = zbx_get_peer_cert(tls_ctx->ctx, &error)))
 	{
@@ -2373,6 +2949,8 @@ static int	zbx_verify_issuer_subject(const zbx_tls_context_t *tls_ctx, const cha
 	size_t			error_alloc = 0, error_offset = 0;
 #if defined(HAVE_POLARSSL)
 	const x509_crt		*cert;
+#elif defined(HAVE_MBEDTLS21)
+	const mbedtls_x509_crt		*cert;
 #elif defined(HAVE_GNUTLS)
 	gnutls_x509_crt_t	cert;
 	gnutls_x509_dn_t	dn;
@@ -2401,6 +2979,24 @@ static int	zbx_verify_issuer_subject(const zbx_tls_context_t *tls_ctx, const cha
 		if (SUCCEED != zbx_x509_dn_gets(&cert->subject, tls_subject, sizeof(tls_subject), error))
 			return FAIL;
 	}
+#elif defined(HAVE_MBEDTLS21)
+	if (NULL == (cert = mbedtls_ssl_get_peer_cert(tls_ctx->ctx)))
+	{
+		*error = zbx_strdup(*error, "cannot obtain peer certificate");
+		return FAIL;
+	}
+
+	if (NULL != issuer && '\0' != *issuer)
+	{
+		if (SUCCEED != zbx_x509_dn_gets(&cert->issuer, tls_issuer, sizeof(tls_issuer), error))
+			return FAIL;
+	}
+
+	if (NULL != subject && '\0' != *subject)
+	{
+		if (SUCCEED != zbx_x509_dn_gets(&cert->subject, tls_subject, sizeof(tls_subject), error))
+			return FAIL;
+	}
 #elif defined(HAVE_GNUTLS)
 	if (NULL == (cert = zbx_get_peer_cert(tls_ctx->ctx, error)))
 		return FAIL;
@@ -2547,6 +3143,8 @@ static void	zbx_tls_library_init(void)
 {
 #if defined(HAVE_POLARSSL)
 	zabbix_log(LOG_LEVEL_DEBUG, "mbed TLS library (version %s)", POLARSSL_VERSION_STRING_FULL);
+#elif defined(HAVE_MBEDTLS21)
+	zabbix_log(LOG_LEVEL_DEBUG, "mbed TLS library (version %s)", MBEDTLS_VERSION_STRING_FULL);
 #elif defined(HAVE_GNUTLS)
 	if (GNUTLS_E_SUCCESS != gnutls_global_init())
 	{
@@ -2812,6 +3410,203 @@ void	zbx_tls_init_child(void)
 #endif
 	zabbix_log(LOG_LEVEL_DEBUG, "End of %s()", __function_name);
 }
+#elif defined(HAVE_MBEDTLS21)
+void	zbx_tls_init_child(void)
+{
+	const char	*__function_name = "zbx_tls_init_child";
+	int		res;
+	unsigned char	pers[64];	/* personalization string obtained from SHA-512 in SHA-384 mode */
+#ifndef _WINDOWS
+	sigset_t	mask, orig_mask;
+#endif
+	zabbix_log(LOG_LEVEL_DEBUG, "In %s()", __function_name);
+
+#ifndef _WINDOWS
+	/* Invalid TLS parameters will cause exit. Once one process exits the parent process will send SIGTERM to */
+	/* child processes which may be on their way to exit on their own - do not interrupt them, block signal */
+	/* SIGTERM and unblock it when TLS parameters are good and libraries are initialized. */
+	sigemptyset(&mask);
+	sigaddset(&mask, SIGTERM);
+	sigprocmask(SIG_BLOCK, &mask, &orig_mask);
+
+	zbx_tls_library_init();		/* on Unix initialize crypto libraries in child processes */
+#endif
+	/* 'TLSCAFile' parameter (in zabbix_server.conf, zabbix_proxy.conf, zabbix_agentd.conf). */
+	if (NULL != CONFIG_TLS_CA_FILE)
+	{
+		ca_cert = zbx_malloc(ca_cert, sizeof(mbedtls_x509_crt));
+		mbedtls_x509_crt_init(ca_cert);
+
+		if (0 != (res = mbedtls_x509_crt_parse_file(ca_cert, CONFIG_TLS_CA_FILE)))
+		{
+			if (0 > res)
+			{
+				zbx_tls_error_msg(res, "", &err_msg);
+				zabbix_log(LOG_LEVEL_CRIT, "cannot parse CA certificate(s) in file \"%s\": %s",
+						CONFIG_TLS_CA_FILE, err_msg);
+				zbx_free(err_msg);
+			}
+			else
+			{
+				zabbix_log(LOG_LEVEL_CRIT, "cannot parse %d CA certificate(s) in file \"%s\"", res,
+						CONFIG_TLS_CA_FILE);
+			}
+
+			zbx_tls_free();
+			exit(EXIT_FAILURE);
+		}
+
+		zabbix_log(LOG_LEVEL_DEBUG, "%s() loaded CA certificate(s) from file \"%s\"", __function_name,
+				CONFIG_TLS_CA_FILE);
+	}
+
+	/* 'TLSCRLFile' parameter (in zabbix_server.conf, zabbix_proxy.conf, zabbix_agentd.conf). */
+	/* Load CRL (certificate revocation list) file. */
+	if (NULL != CONFIG_TLS_CRL_FILE)
+	{
+		crl = zbx_malloc(crl, sizeof(mbedtls_x509_crl));
+		mbedtls_x509_crl_init(crl);
+
+		if (0 != (res = mbedtls_x509_crl_parse_file(crl, CONFIG_TLS_CRL_FILE)))
+		{
+			zbx_tls_error_msg(res, "", &err_msg);
+			zabbix_log(LOG_LEVEL_CRIT, "cannot parse CRL file \"%s\": %s", CONFIG_TLS_CRL_FILE, err_msg);
+			zbx_free(err_msg);
+
+			zbx_tls_free();
+			exit(EXIT_FAILURE);
+		}
+
+		zabbix_log(LOG_LEVEL_DEBUG, "%s() loaded CRL(s) from file \"%s\"", __function_name,
+				CONFIG_TLS_CRL_FILE);
+	}
+
+	/* 'TLSCertFile' parameter (in zabbix_server.conf, zabbix_proxy.conf, zabbix_agentd.conf). */
+	/* Load certificate. */
+	if (NULL != CONFIG_TLS_CERT_FILE)
+	{
+		my_cert = zbx_malloc(my_cert, sizeof(mbedtls_x509_crt));
+		mbedtls_x509_crt_init(my_cert);
+
+		if (0 != (res = mbedtls_x509_crt_parse_file(my_cert, CONFIG_TLS_CERT_FILE)))
+		{
+			if (0 > res)
+			{
+				zbx_tls_error_msg(res, "", &err_msg);
+				zabbix_log(LOG_LEVEL_CRIT, "cannot parse certificate(s) in file \"%s\": %s",
+						CONFIG_TLS_CERT_FILE, err_msg);
+				zbx_free(err_msg);
+			}
+			else
+			{
+				zabbix_log(LOG_LEVEL_CRIT, "cannot parse %d certificate(s) in file \"%s\"", res,
+						CONFIG_TLS_CERT_FILE);
+			}
+
+			zbx_tls_free();
+			exit(EXIT_FAILURE);
+		}
+
+		zabbix_log(LOG_LEVEL_DEBUG, "%s() loaded certificate from file \"%s\"", __function_name,
+				CONFIG_TLS_CERT_FILE);
+	}
+
+	/* 'TLSKeyFile' parameter (in zabbix_server.conf, zabbix_proxy.conf, zabbix_agentd.conf). */
+	/* Load private key. */
+	if (NULL != CONFIG_TLS_KEY_FILE)
+	{
+		my_priv_key = zbx_malloc(my_priv_key, sizeof(mbedtls_pk_context));
+		mbedtls_pk_init(my_priv_key);
+
+		/* The 3rd argument of mbedtls_pk_parse_keyfile() is password for decrypting the private key. */
+		/* Currently the password is not used, it is empty. */
+		if (0 != (res = mbedtls_pk_parse_keyfile(my_priv_key, CONFIG_TLS_KEY_FILE, "")))
+		{
+			zbx_tls_error_msg(res, "", &err_msg);
+			zabbix_log(LOG_LEVEL_CRIT, "cannot parse the private key in file \"%s\": %s",
+					CONFIG_TLS_KEY_FILE, err_msg);
+			zbx_free(err_msg);
+			zbx_tls_free();
+			exit(EXIT_FAILURE);
+		}
+
+		zabbix_log(LOG_LEVEL_DEBUG, "%s() loaded " ZBX_FS_SIZE_T "-bit %s private key from file \"%s\"",
+				__function_name, (zbx_fs_size_t)mbedtls_pk_get_bitlen(my_priv_key), mbedtls_pk_get_name(my_priv_key),
+				CONFIG_TLS_KEY_FILE);
+	}
+
+	/* 'TLSPSKFile' parameter (in zabbix_proxy.conf, zabbix_agentd.conf). */
+	/* Load pre-shared key. */
+	if (NULL != CONFIG_TLS_PSK_FILE)
+	{
+		zbx_read_psk_file();
+		zabbix_log(LOG_LEVEL_DEBUG, "%s() loaded PSK from file \"%s\"", __function_name, CONFIG_TLS_PSK_FILE);
+	}
+
+	/* 'TLSPSKIdentity' parameter (in zabbix_proxy.conf, zabbix_agentd.conf). */
+	/* Configure identity to be used with the pre-shared key. */
+	if (NULL != CONFIG_TLS_PSK_IDENTITY)
+	{
+		my_psk_identity = CONFIG_TLS_PSK_IDENTITY;
+		my_psk_identity_len = strlen(my_psk_identity);
+
+		zbx_check_psk_identity_len(my_psk_identity_len);
+
+		zabbix_log(LOG_LEVEL_DEBUG, "%s() loaded PSK identity \"%s\"", __function_name,
+				CONFIG_TLS_PSK_IDENTITY);
+	}
+
+	/* Certificate always comes from configuration file. Set up ciphersuites. */
+	if (NULL != my_cert)
+	{
+		zbx_ciphersuites(ZBX_TLS_CIPHERSUITE_CERT, &ciphersuites_cert);
+		zbx_log_ciphersuites(__function_name, "certificate", ciphersuites_cert);
+	}
+
+	/* PSK can come from configuration file (in proxy, agentd) and later from database (in server, proxy). */
+	/* Configure ciphersuites just in case they will be used. */
+	if (NULL != my_psk || 0 != (program_type & (ZBX_PROGRAM_TYPE_SERVER | ZBX_PROGRAM_TYPE_PROXY)))
+	{
+		zbx_ciphersuites(ZBX_TLS_CIPHERSUITE_PSK, &ciphersuites_psk);
+		zbx_log_ciphersuites(__function_name, "PSK", ciphersuites_psk);
+	}
+
+	/* Sometimes we need to be ready for both certificate and PSK whichever comes in. Set up a combined list of */
+	/* ciphersuites. */
+	if (NULL != my_cert && (NULL != my_psk ||
+			0 != (program_type & (ZBX_PROGRAM_TYPE_SERVER | ZBX_PROGRAM_TYPE_PROXY))))
+	{
+		zbx_ciphersuites(ZBX_TLS_CIPHERSUITE_ALL, &ciphersuites_all);
+		zbx_log_ciphersuites(__function_name, "certificate and PSK", ciphersuites_all);
+	}
+
+	entropy = zbx_malloc(entropy, sizeof(mbedtls_entropy_context));
+	mbedtls_entropy_init(entropy);
+
+	zbx_make_personalization_string(pers);
+
+	ctr_drbg = zbx_malloc(ctr_drbg, sizeof(mbedtls_ctr_drbg_context));
+	mbedtls_ctr_drbg_init(ctr_drbg);
+
+	if (0 != (res = mbedtls_ctr_drbg_seed(ctr_drbg, mbedtls_entropy_func, entropy, pers, 48)))
+		/* PolarSSL mbedtls_sha512_finish() in SHA-384 mode returns an array "unsigned char output[64]" where result */
+		/* resides in the first 48 bytes and the last 16 bytes are not used */
+	{
+		zbx_guaranteed_memset(pers, 0, sizeof(pers));
+		zbx_tls_error_msg(res, "", &err_msg);
+		zabbix_log(LOG_LEVEL_CRIT, "cannot initialize random number generator: %s", err_msg);
+		zbx_free(err_msg);
+		zbx_tls_free();
+		exit(EXIT_FAILURE);
+	}
+
+	zbx_guaranteed_memset(pers, 0, sizeof(pers));
+
+#ifndef _WINDOWS
+	sigprocmask(SIG_SETMASK, &orig_mask, NULL);
+#endif
+	zabbix_log(LOG_LEVEL_DEBUG, "End of %s()", __function_name);
+}
 #elif defined(HAVE_GNUTLS)
 void	zbx_tls_init_child(void)
 {
@@ -3516,6 +4311,53 @@ void	zbx_tls_free(void)
 	zbx_free(ciphersuites_psk);
 	zbx_free(ciphersuites_cert);
 	zbx_free(ciphersuites_all);
+#elif defined(HAVE_MBEDTLS21)
+	if (NULL != ctr_drbg)
+	{
+		mbedtls_ctr_drbg_free(ctr_drbg);
+		zbx_free(ctr_drbg);
+	}
+
+	if (NULL != entropy)
+	{
+		mbedtls_entropy_free(entropy);
+		zbx_free(entropy);
+	}
+
+	if (NULL != my_psk)
+	{
+		zbx_guaranteed_memset(my_psk, 0, my_psk_len);
+		my_psk_len = 0;
+		zbx_free(my_psk);
+	}
+
+	if (NULL != my_priv_key)
+	{
+		mbedtls_pk_free(my_priv_key);
+		zbx_free(my_priv_key);
+	}
+
+	if (NULL != my_cert)
+	{
+		mbedtls_x509_crt_free(my_cert);
+		zbx_free(my_cert);
+	}
+
+	if (NULL != crl)
+	{
+		mbedtls_x509_crl_free(crl);
+		zbx_free(crl);
+	}
+
+	if (NULL != ca_cert)
+	{
+		mbedtls_x509_crt_free(ca_cert);
+		zbx_free(ca_cert);
+	}
+
+	zbx_free(ciphersuites_psk);
+	zbx_free(ciphersuites_cert);
+	zbx_free(ciphersuites_all);
 #elif defined(HAVE_GNUTLS)
 	if (NULL != my_cert_creds)
 	{
@@ -3690,27 +4532,245 @@ int	zbx_tls_connect(zbx_socket_t *s, unsigned int tls_connect, char *tls_arg1, c
 		ssl_set_ciphersuites(s->tls_ctx->ctx, ciphersuites_cert);
 
 		/* set CA certificate and certificate revocation lists */
-		ssl_set_ca_chain(s->tls_ctx->ctx, ca_cert, crl, NULL);
+		ssl_set_ca_chain(s->tls_ctx->ctx, ca_cert, crl, NULL);
+
+		if (0 != (res = ssl_set_own_cert(s->tls_ctx->ctx, my_cert, my_priv_key)))
+		{
+			zbx_tls_error_msg(res, "ssl_set_own_cert(): ", error);
+			goto out;
+		}
+	}
+	else	/* use a pre-shared key */
+	{
+		ssl_set_ciphersuites(s->tls_ctx->ctx, ciphersuites_psk);
+
+		if (NULL == tls_arg2)	/* PSK is not set from DB */
+		{
+			/* set up the PSK from a configuration file (always in agentd and a case in active proxy */
+			/* when it connects to server) */
+
+			if (0 != (res = ssl_set_psk(s->tls_ctx->ctx, (const unsigned char *)my_psk, my_psk_len,
+					(const unsigned char *)my_psk_identity, my_psk_identity_len)))
+			{
+				zbx_tls_error_msg(res, "ssl_set_psk(): ", error);
+				goto out;
+			}
+		}
+		else
+		{
+			/* PSK comes from a database (case for a server/proxy when it connects to an agent for */
+			/* passive checks, for a server when it connects to a passive proxy) */
+
+			int	psk_len;
+			char	psk_buf[HOST_TLS_PSK_LEN / 2];
+
+			if (0 >= (psk_len = zbx_psk_hex2bin((unsigned char *)tls_arg2, (unsigned char *)psk_buf,
+					sizeof(psk_buf))))
+			{
+				*error = zbx_strdup(*error, "invalid PSK");
+				goto out;
+			}
+
+			if (0 != (res = ssl_set_psk(s->tls_ctx->ctx, (const unsigned char *)psk_buf, (size_t)psk_len,
+					(const unsigned char *)tls_arg1, strlen(tls_arg1))))
+			{
+				zbx_tls_error_msg(res, "ssl_set_psk(): ", error);
+				goto out;
+			}
+		}
+	}
+
+#if defined(_WINDOWS)
+	zbx_alarm_flag_clear();
+	sec = zbx_time();
+#endif
+	while (0 != (res = ssl_handshake(s->tls_ctx->ctx)))
+	{
+#if defined(_WINDOWS)
+		if (s->timeout < zbx_time() - sec)
+			zbx_alarm_flag_set();
+#endif
+		if (SUCCEED == zbx_alarm_timed_out())
+		{
+			*error = zbx_strdup(*error, "ssl_handshake() timed out");
+			goto out;
+		}
+
+		if (POLARSSL_ERR_NET_WANT_READ != res && POLARSSL_ERR_NET_WANT_WRITE != res)
+		{
+			if (POLARSSL_ERR_X509_CERT_VERIFY_FAILED == res)
+			{
+				/* Standard PolarSSL error message might not be very informative in this case. For */
+				/* example, if certificate validity starts in future, PolarSSL 1.3.9 would produce a */
+				/* message "X509 - Certificate verification failed, e.g. CRL, CA or signature check */
+				/* failed" which does not give a precise reason. Here we try to get more detailed */
+				/* reason why peer certificate was rejected by using some knowledge about PolarSSL */
+				/* internals. */
+				zbx_tls_cert_error_msg((unsigned int)s->tls_ctx->ctx->session_negotiate->verify_result,
+						error);
+				zbx_tls_close(s);
+				goto out1;
+			}
+
+			zbx_tls_error_msg(res, "ssl_handshake(): ", error);
+			goto out;
+		}
+	}
+
+	if (ZBX_TCP_SEC_TLS_CERT == tls_connect)
+	{
+		/* log peer certificate information for debugging */
+		zbx_log_peer_cert(__function_name, s->tls_ctx);
+
+		/* basic verification of peer certificate was done during handshake */
+
+		/* if required verify peer certificate Issuer and Subject */
+		if (SUCCEED != zbx_verify_issuer_subject(s->tls_ctx, tls_arg1, tls_arg2, error))
+		{
+			zbx_tls_close(s);
+			goto out1;
+		}
+	}
+	else	/* pre-shared key */
+	{
+		if (SUCCEED == zabbix_check_log_level(LOG_LEVEL_DEBUG))
+		{
+			/* special print: s->tls_ctx->ctx->psk_identity is not '\0'-terminated */
+			zabbix_log(LOG_LEVEL_DEBUG, "%s() PSK identity: \"%.*s\"", __function_name,
+					(int)s->tls_ctx->ctx->psk_identity_len, s->tls_ctx->ctx->psk_identity);
+		}
+	}
+
+	s->connection_type = tls_connect;
+
+	if (SUCCEED == zabbix_check_log_level(LOG_LEVEL_DEBUG))
+	{
+		zabbix_log(LOG_LEVEL_DEBUG, "End of %s():SUCCEED (established %s %s)", __function_name,
+				ssl_get_version(s->tls_ctx->ctx), ssl_get_ciphersuite(s->tls_ctx->ctx));
+	}
+
+	return SUCCEED;
+
+out:	/* an error occurred */
+	ssl_free(s->tls_ctx->ctx);
+	zbx_free(s->tls_ctx->ctx);
+	zbx_free(s->tls_ctx);
+out1:
+	zabbix_log(LOG_LEVEL_DEBUG, "End of %s():%s error:'%s'", __function_name, zbx_result_string(ret),
+			ZBX_NULL2EMPTY_STR(*error));
+	return ret;
+}
+#elif defined(HAVE_MBEDTLS21)
+int	zbx_tls_connect(zbx_socket_t *s, unsigned int tls_connect, char *tls_arg1, char *tls_arg2, char **error)
+{
+	const char	*__function_name = "zbx_tls_connect";
+	int		ret = FAIL, res;
+#if defined(_WINDOWS)
+	double		sec;
+#endif
+	if (ZBX_TCP_SEC_TLS_CERT == tls_connect)
+	{
+		zabbix_log(LOG_LEVEL_DEBUG, "In %s(): issuer:\"%s\" subject:\"%s\"", __function_name,
+				ZBX_NULL2EMPTY_STR(tls_arg1), ZBX_NULL2EMPTY_STR(tls_arg2));
+
+		if (NULL == ciphersuites_cert)
+		{
+			*error = zbx_strdup(*error, "cannot connect with TLS and certificate: no valid certificate"
+					" loaded");
+			goto out1;
+		}
+	}
+	else if (ZBX_TCP_SEC_TLS_PSK == tls_connect)
+	{
+		zabbix_log(LOG_LEVEL_DEBUG, "In %s(): psk_identity:\"%s\"", __function_name,
+				ZBX_NULL2EMPTY_STR(tls_arg1));
+
+		if (NULL == ciphersuites_psk)
+		{
+			*error = zbx_strdup(*error, "cannot connect with TLS and PSK: no valid PSK loaded");
+			goto out1;
+		}
+	}
+	else
+	{
+		*error = zbx_strdup(*error, "invalid connection parameters");
+		THIS_SHOULD_NEVER_HAPPEN;
+		goto out1;
+	}
+
+	/* set up TLS context */
+
+	s->tls_ctx = zbx_malloc(s->tls_ctx, sizeof(zbx_tls_context_t));
+	s->tls_ctx->conf = zbx_malloc(NULL, sizeof(mbedtls_ssl_config));
+	mbedtls_ssl_config_init(s->tls_ctx->conf);
+	s->tls_ctx->ctx = zbx_malloc(NULL, sizeof(mbedtls_ssl_context));
+	mbedtls_ssl_init(s->tls_ctx->ctx);
+
+	if (0 != (res = mbedtls_ssl_config_defaults(s->tls_ctx->conf,
+			MBEDTLS_SSL_IS_CLIENT, MBEDTLS_SSL_TRANSPORT_STREAM, MBEDTLS_SSL_PRESET_DEFAULT)))
+	{
+		zbx_tls_error_msg(res, "mbedtls_ssl_config_defaults(): ", error);
+		goto out_pre_setup;
+	}
+
+	if (0 != (res = mbedtls_ssl_setup(s->tls_ctx->ctx, s->tls_ctx->conf)))
+	{
+		zbx_tls_error_msg(res, "mbedtls_ssl_setup(): ", error);
+		goto out;
+	}
+
+	/* Set RNG callback where to get random numbers from */
+	mbedtls_ssl_conf_rng(s->tls_ctx->conf, mbedtls_ctr_drbg_random, ctr_drbg);
+
+	/* disable using of session tickets (by default it is enabled on client) */
+	mbedtls_ssl_conf_session_tickets(s->tls_ctx->conf, MBEDTLS_SSL_SESSION_TICKETS_DISABLED);
+
+	if (SUCCEED == zabbix_check_log_level(LOG_LEVEL_TRACE))
+	{
+		/* Set our own debug callback function. The 3rd parameter of mbedtls_ssl_conf_dbg() we set to NULL. It will be */
+		/* passed as the 1st parameter to our callback function and will be ignored there. */
+		mbedtls_ssl_conf_dbg(s->tls_ctx->conf, polarssl_debug_cb, NULL);
+
+		/* For Zabbix LOG_LEVEL_TRACE, PolarSSL debug level 3 seems the best. Recompile with 4 (apparently */
+		/* the highest PolarSSL debug level) to dump also network raw bytes. */
+		mbedtls_debug_set_threshold(3);
+	}
+
+	/* Set callback functions for receiving and sending data via socket. */
+	/* Functions provided by PolarSSL work well so far, no need to invent our own. */
+	mbedtls_ssl_set_bio(s->tls_ctx->ctx, &s->socket, mbedtls_net_send, mbedtls_net_recv, NULL);
+
+	/* set protocol version to TLS 1.2 */
+	mbedtls_ssl_conf_min_version(s->tls_ctx->conf, ZBX_TLS_MIN_MAJOR_VER, ZBX_TLS_MIN_MINOR_VER);
+	mbedtls_ssl_conf_max_version(s->tls_ctx->conf, ZBX_TLS_MAX_MAJOR_VER, ZBX_TLS_MAX_MINOR_VER);
+
+	if (ZBX_TCP_SEC_TLS_CERT == tls_connect)	/* use certificates */
+	{
+		mbedtls_ssl_conf_authmode(s->tls_ctx->conf, MBEDTLS_SSL_VERIFY_REQUIRED);
+		mbedtls_ssl_conf_ciphersuites(s->tls_ctx->conf, ciphersuites_cert);
+
+		/* set CA certificate and certificate revocation lists */
+		mbedtls_ssl_conf_ca_chain(s->tls_ctx->conf, ca_cert, crl);
 
-		if (0 != (res = ssl_set_own_cert(s->tls_ctx->ctx, my_cert, my_priv_key)))
+		if (0 != (res = mbedtls_ssl_conf_own_cert(s->tls_ctx->conf, my_cert, my_priv_key)))
 		{
-			zbx_tls_error_msg(res, "ssl_set_own_cert(): ", error);
+			zbx_tls_error_msg(res, "mbedtls_ssl_conf_own_cert(): ", error);
 			goto out;
 		}
 	}
 	else	/* use a pre-shared key */
 	{
-		ssl_set_ciphersuites(s->tls_ctx->ctx, ciphersuites_psk);
+		mbedtls_ssl_conf_ciphersuites(s->tls_ctx->conf, ciphersuites_psk);
 
 		if (NULL == tls_arg2)	/* PSK is not set from DB */
 		{
 			/* set up the PSK from a configuration file (always in agentd and a case in active proxy */
 			/* when it connects to server) */
 
-			if (0 != (res = ssl_set_psk(s->tls_ctx->ctx, (const unsigned char *)my_psk, my_psk_len,
+			if (0 != (res = mbedtls_ssl_conf_psk(s->tls_ctx->conf, (const unsigned char *)my_psk, my_psk_len,
 					(const unsigned char *)my_psk_identity, my_psk_identity_len)))
 			{
-				zbx_tls_error_msg(res, "ssl_set_psk(): ", error);
+				zbx_tls_error_msg(res, "mbedtls_ssl_conf_psk(): ", error);
 				goto out;
 			}
 		}
@@ -3729,10 +4789,10 @@ int	zbx_tls_connect(zbx_socket_t *s, unsigned int tls_connect, char *tls_arg1, c
 				goto out;
 			}
 
-			if (0 != (res = ssl_set_psk(s->tls_ctx->ctx, (const unsigned char *)psk_buf, (size_t)psk_len,
+			if (0 != (res = mbedtls_ssl_conf_psk(s->tls_ctx->conf, (const unsigned char *)psk_buf, (size_t)psk_len,
 					(const unsigned char *)tls_arg1, strlen(tls_arg1))))
 			{
-				zbx_tls_error_msg(res, "ssl_set_psk(): ", error);
+				zbx_tls_error_msg(res, "mbedtls_ssl_conf_psk(): ", error);
 				goto out;
 			}
 		}
@@ -3742,7 +4802,7 @@ int	zbx_tls_connect(zbx_socket_t *s, unsigned int tls_connect, char *tls_arg1, c
 	zbx_alarm_flag_clear();
 	sec = zbx_time();
 #endif
-	while (0 != (res = ssl_handshake(s->tls_ctx->ctx)))
+	while (0 != (res = mbedtls_ssl_handshake(s->tls_ctx->ctx)))
 	{
 #if defined(_WINDOWS)
 		if (s->timeout < zbx_time() - sec)
@@ -3750,13 +4810,13 @@ int	zbx_tls_connect(zbx_socket_t *s, unsigned int tls_connect, char *tls_arg1, c
 #endif
 		if (SUCCEED == zbx_alarm_timed_out())
 		{
-			*error = zbx_strdup(*error, "ssl_handshake() timed out");
+			*error = zbx_strdup(*error, "mbedtls_ssl_handshake() timed out");
 			goto out;
 		}
 
-		if (POLARSSL_ERR_NET_WANT_READ != res && POLARSSL_ERR_NET_WANT_WRITE != res)
+		if (MBEDTLS_ERR_SSL_WANT_READ != res && MBEDTLS_ERR_SSL_WANT_WRITE != res)
 		{
-			if (POLARSSL_ERR_X509_CERT_VERIFY_FAILED == res)
+			if (MBEDTLS_ERR_X509_CERT_VERIFY_FAILED == res)
 			{
 				/* Standard PolarSSL error message might not be very informative in this case. For */
 				/* example, if certificate validity starts in future, PolarSSL 1.3.9 would produce a */
@@ -3770,7 +4830,7 @@ int	zbx_tls_connect(zbx_socket_t *s, unsigned int tls_connect, char *tls_arg1, c
 				goto out1;
 			}
 
-			zbx_tls_error_msg(res, "ssl_handshake(): ", error);
+			zbx_tls_error_msg(res, "mbedtls_ssl_handshake(): ", error);
 			goto out;
 		}
 	}
@@ -3795,7 +4855,7 @@ int	zbx_tls_connect(zbx_socket_t *s, unsigned int tls_connect, char *tls_arg1, c
 		{
 			/* special print: s->tls_ctx->ctx->psk_identity is not '\0'-terminated */
 			zabbix_log(LOG_LEVEL_DEBUG, "%s() PSK identity: \"%.*s\"", __function_name,
-					(int)s->tls_ctx->ctx->psk_identity_len, s->tls_ctx->ctx->psk_identity);
+					(int)s->tls_ctx->conf->psk_identity_len, s->tls_ctx->conf->psk_identity);
 		}
 	}
 
@@ -3804,14 +4864,17 @@ int	zbx_tls_connect(zbx_socket_t *s, unsigned int tls_connect, char *tls_arg1, c
 	if (SUCCEED == zabbix_check_log_level(LOG_LEVEL_DEBUG))
 	{
 		zabbix_log(LOG_LEVEL_DEBUG, "End of %s():SUCCEED (established %s %s)", __function_name,
-				ssl_get_version(s->tls_ctx->ctx), ssl_get_ciphersuite(s->tls_ctx->ctx));
+				mbedtls_ssl_get_version(s->tls_ctx->ctx), mbedtls_ssl_get_ciphersuite(s->tls_ctx->ctx));
 	}
 
 	return SUCCEED;
 
 out:	/* an error occurred */
-	ssl_free(s->tls_ctx->ctx);
+	mbedtls_ssl_free(s->tls_ctx->ctx);
 	zbx_free(s->tls_ctx->ctx);
+out_pre_setup:
+	mbedtls_ssl_config_free(s->tls_ctx->conf);
+	zbx_free(s->tls_ctx->conf);
 	zbx_free(s->tls_ctx);
 out1:
 	zabbix_log(LOG_LEVEL_DEBUG, "End of %s():%s error:'%s'", __function_name, zbx_result_string(ret),
